SystemOrganization addCategory: #'Path-Dev-Evaluation-Wrapper'!
SystemOrganization addCategory: #'Path-Dev-Evaluation'!
SystemOrganization addCategory: #'Path-Dev-Example-Observer'!
SystemOrganization addCategory: #'Path-Dev-Scripts'!

MwMethodWrapper subclass: #STestCoverageWrapper
	instanceVariableNames: 'tests currentTest'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Dev-Evaluation-Wrapper'!

!STestCoverageWrapper methodsFor: 'evaluating' stamp: 'mp 2/6/2010 15:09'!
beforeMethod
	
	self currentTest ifNotNil: [self tests add: self currentTest].! !

!STestCoverageWrapper methodsFor: 'accessing' stamp: 'mp 1/28/2010 17:56'!
currentTest
	"Answer the value of currentTest"

	^ currentTest! !

!STestCoverageWrapper methodsFor: 'accessing' stamp: 'mp 1/28/2010 17:56'!
currentTest: anObject
	"Set the value of currentTest"

	currentTest := anObject! !

!STestCoverageWrapper methodsFor: 'initialize-release' stamp: 'mp 1/28/2010 17:57'!
initialize

	self tests: Set new.! !

!STestCoverageWrapper methodsFor: 'accessing' stamp: 'mp 1/28/2010 17:56'!
tests
	"Answer the value of tests"

	^ tests! !

!STestCoverageWrapper methodsFor: 'accessing' stamp: 'mp 1/28/2010 17:56'!
tests: anObject
	"Set the value of tests"

	tests := anObject! !

Object subclass: #Driver
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Dev-Example-Observer'!

!Driver class methodsFor: 'demo' stamp: 'tfel 2/14/2012 10:13:15.594'!
demo
	| timer analogClock digitalClock |

	timer := ClockTimer new.
	analogClock := SAnalogClock newOn: timer inFrame: (0@50 extent: 400@100).
	digitalClock := SDigitalClock newOn: timer inFrame: (0@150 extent: 200@210).
	1000 timesRepeat: [
		(Delay forMilliseconds: 10) wait.
		timer tick].
	(Delay forSeconds: 3) wait.
	World changed.! !

!Driver methodsFor: 'running' stamp: 'tfel 2/14/2012 10:13:10.642'!
run
	| timer analogClock digitalClock |

	timer := ClockTimer new.
	analogClock := SAnalogClock on: timer.
	digitalClock := SDigitalClock on: timer.
	
	timer tick.! !

Object subclass: #Observer
	instanceVariableNames: 'subject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Dev-Example-Observer'!

!Observer class methodsFor: 'as yet unclassified' stamp: 'mp 4/28/2010 14:12'!
on: aSubject
	| observer |
	observer := self new
				subject: aSubject;
				yourself.
	aSubject attach: observer.
	^ observer.! !

!Observer methodsFor: 'accessing' stamp: 'mp 4/28/2010 14:11'!
subject
	"Answer the value of subject"

	^ subject! !

!Observer methodsFor: 'accessing' stamp: 'mp 4/28/2010 14:11'!
subject: anObject
	"Set the value of subject"

	subject := anObject! !

!Observer methodsFor: 'observation' stamp: 'mp 4/28/2010 14:11'!
update: aSubject

	self subclassResponsibility.! !

Observer subclass: #SVisibleClock
	instanceVariableNames: 'frame para'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Dev-Example-Observer'!

SVisibleClock subclass: #SAnalogClock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Dev-Example-Observer'!

!SAnalogClock methodsFor: 'private' stamp: 'tfel 2/14/2012 10:11:31.204'!
draw
	| hour minute second str |

	hour := subject hour.
	minute := subject minute.
	second := subject second.
	
	"draw the digital clock"
	str := String streamContents: [:s |
		s nextPutAll: 'H '.
		hour timesRepeat: [s nextPut: $-].
		s cr; nextPutAll: 'M '.
		minute timesRepeat: [s nextPut: $-].
		s cr; nextPutAll: 'S '.
		second timesRepeat: [s nextPut: $-]].
	self drawText: str.! !

!SAnalogClock methodsFor: 'observation' stamp: 'tfel 2/14/2012 10:11:41.446'!
update: aSubject
	aSubject = subject ifTrue: [ self draw]! !

SVisibleClock subclass: #SDigitalClock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Dev-Example-Observer'!

!SDigitalClock methodsFor: 'private' stamp: 'tfel 1/26/2012 21:18:21.804'!
draw
	| hour minute second |

	hour := subject hour.
	minute := subject minute.
	second := subject second.
	
	"draw the digital clock"
	self drawText: (hour asString padded: #left to: 2 with: $0), ':',
					(minute asString padded: #left to: 2 with: $0), ':',
					(second asString padded: #left to: 2 with: $0).! !

!SDigitalClock methodsFor: 'observation' stamp: 'mp 3/19/2011 18:26:20.3'!
update: aSubject
	aSubject = subject ifTrue: [self draw]! !

!SVisibleClock class methodsFor: 'constants' stamp: 'tfel 2/14/2012 10:17:37.717'!
defaultExtent

	^ 0@50 extent: 400@100! !

!SVisibleClock class methodsFor: 'instance creation' stamp: 'tfel 2/14/2012 10:17:44.691'!
newOn: timer inFrame: frame

	^ (self on: timer)
		initInFrame: frame;
		yourself! !

!SVisibleClock class methodsFor: 'instance creation' stamp: 'tfel 2/14/2012 10:17:19.44'!
on: timer

	^ (super on: timer)
		initInFrame: self defaultExtent;
		yourself! !

!SVisibleClock methodsFor: 'private' stamp: 'tfel 1/26/2012 21:26:30.546'!
drawText: aString

	para setWithText: aString asText
		style: TextStyle default
		compositionRectangle: ((frame insetBy: 4) withHeight: 9999)
		clippingRectangle: frame
		foreColor: Color black backColor: Color white.
	para display.! !

!SVisibleClock methodsFor: 'private' stamp: 'tfel 1/26/2012 20:59:23.848'!
initInFrame: rect
	frame := rect insetBy: 2.  "Leave room for border"
	(Smalltalk hasClassNamed: #Paragraph)
		ifFalse: [^ self inform: 'MVC class Paragraph not present'].
	para := (Smalltalk at: #Paragraph) withText: '' asText
				style: TextStyle default
				compositionRectangle: ((frame insetBy: 4) withHeight: 9999)
				clippingRectangle: frame
				foreColor: Color black backColor: Color white! !

Object subclass: #SAbstractEvaluator
	instanceVariableNames: 'measurements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Dev-Evaluation'!

!SAbstractEvaluator class methodsFor: 'constants' stamp: 'mp 11/28/2012 14:18:41.003'!
evaluatedProjects
	
	^ #(sandbox)! !

!SAbstractEvaluator class methodsFor: 'constants' stamp: 'mp 11/28/2012 14:16:47.759'!
fileName
	
	self subclassResponsibility.! !

!SAbstractEvaluator class methodsFor: 'constants' stamp: 'mp 11/28/2012 14:28:34.526'!
measurementHeaders

	self subclassResponsibility.! !

!SAbstractEvaluator class methodsFor: 'constants' stamp: 'mp 11/28/2012 14:18:52.653'!
repetition

	^ 1! !

!SAbstractEvaluator class methodsFor: 'public api' stamp: 'mp 11/28/2012 14:16:55.333'!
run

	^ self new storeMeasurements! !

!SAbstractEvaluator methodsFor: 'file handling' stamp: 'mp 11/28/2012 15:32:13.956'!
convertMeasurementsToCsvOn: aStream
	self measurements withIndexDo: [:row :index |
		aStream nextPutAll: index asString.
		aStream nextPut: $,.
		row do: [:each | 
			aStream nextPutAll: each asString.
			aStream nextPut: $,.].
		aStream cr; flush.].! !

!SAbstractEvaluator methodsFor: 'helper' stamp: 'mp 11/29/2012 15:49:59.895'!
createDynamicTracerModel

	| tracer model |
	tracer := SCallgraphTracer on: SProject current.
	model := SCallgraphModel on: tracer.
	tracer callgraphModel: model.	
	^ tracer! !

!SAbstractEvaluator methodsFor: 'measurements' stamp: 'mp 11/28/2012 14:28:10.242'!
createMeasurementHeader
	self measurements
			add: (OrderedCollection with: SProject current);
			add: self class measurementHeaders.! !

!SAbstractEvaluator methodsFor: 'helper' stamp: 'mp 11/28/2012 14:22:38.916'!
do: aBlock withCurrentProject: aProjectName
	| previousCurrentProject result |
	[previousCurrentProject := SProject current.
	SProject setCurrent: aProjectName.
	result := aBlock value]
		ensure: [SProject setCurrentProject: previousCurrentProject].
	^ result! !

!SAbstractEvaluator methodsFor: 'file handling' stamp: 'mp 11/28/2012 15:28:02.948'!
generateFileName
	| time stream |
	time := DateAndTime now.
	stream := WriteStream on: String new.
	stream
		nextPutAll: (time year asString copyFrom: 3 to: 4);
		nextPutAll: time month asString;
		nextPutAll: time dayOfMonth asString;
		nextPutAll: '_';
		nextPutAll: time hour asString;
		nextPutAll: time minutes asString;
		nextPutAll: '_';
		nextPutAll: self class fileName;
		nextPutAll: '.csv'.
	^ stream contents! !

!SAbstractEvaluator methodsFor: 'helper' stamp: 'mp 11/28/2012 16:26:35.96'!
getCurrentMemoryConsumption
	"Browse: [SmalltalkImage vmStatisticsReportString]"
	| params youngSpaceEnd |
	Smalltalk garbageCollect.
	params := SmalltalkImage current getVMParameters.
	youngSpaceEnd := params at: 2.
	^ youngSpaceEnd! !

!SAbstractEvaluator methodsFor: 'accessing' stamp: 'mp 11/28/2012 14:18:03.071'!
measurements
	"Answer the value of measurements"

	^ measurements ifNil: [measurements := OrderedCollection new]! !

!SAbstractEvaluator methodsFor: 'accessing' stamp: 'mp 11/28/2012 14:16:17.299'!
measurements: anObject
	"Set the value of measurements"

	measurements := anObject! !

!SAbstractEvaluator methodsFor: 'hooks' stamp: 'mp 11/28/2012 14:26:00.522'!
runMeasurements

	self subclassResponsibility.! !

!SAbstractEvaluator methodsFor: 'helper' stamp: 'mp 11/28/2012 16:25:15.88'!
runTest: aTestMethodReference
	^ (STestCaseEntryPoint onTestMethodReference: aTestMethodReference) execute! !

!SAbstractEvaluator methodsFor: 'file handling' stamp: 'mp 11/28/2012 15:29:13.618'!
saveIntoFile
	| file |
	[file := FileDirectory default forceNewFileNamed: self generateFileName.
	self convertMeasurementsToCsvOn: file]
		ensure: [file close].
	! !

!SAbstractEvaluator methodsFor: 'measurements' stamp: 'mp 11/28/2012 15:53:01.962'!
storeMeasurements
	self class evaluatedProjects do: [:each | 
		self do: [self
					createMeasurementHeader;
					runMeasurements]
			withCurrentProject: each].
	self saveIntoFile.
	^ self measurements! !

SAbstractEvaluator subclass: #SAbstractEvaluatorWithPathMap
	instanceVariableNames: 'pathMap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Dev-Evaluation'!

!SAbstractEvaluatorWithPathMap methodsFor: 'initialize-release' stamp: 'mp 11/28/2012 16:01:29.192'!
initializePathMap
	| testRunner |
	testRunner := ToolBuilder build: SPathMapTestRunner new.
	self pathMap: testRunner model pathMap.
	self pathMap globalOptions
		switchShowQuickAndAccessorMethods;
		switchShowMethodCategories;
		switchVisualizeIntermediateSteps.! !

!SAbstractEvaluatorWithPathMap methodsFor: 'analysis' stamp: 'mp 11/28/2012 16:02:21.062'!
methodsCoveredByTests
	^ self methodsCoveredByTestsOn: #testQuality.! !

!SAbstractEvaluatorWithPathMap methodsFor: 'analysis' stamp: 'mp 11/28/2012 16:02:43.437'!
methodsCoveredByTestsOn: aSymbol
	self pathMap runTests: #suiteAll with: aSymbol.
	^ self pathMap tracer getAllCoveredMethods keys 
		reject: [:each | ((each methodSymbol beginsWith: 'test') 
						or: [each compiledMethod isQuick])
						or: [each actualClass inheritsFrom: TestCase]].! !

!SAbstractEvaluatorWithPathMap methodsFor: 'accessing' stamp: 'mp 11/28/2012 16:01:00.351'!
pathMap
	"Answer the value of pathMap"

	^ pathMap! !

!SAbstractEvaluatorWithPathMap methodsFor: 'accessing' stamp: 'mp 11/28/2012 16:01:00.364'!
pathMap: anObject
	"Set the value of pathMap"

	pathMap := anObject! !

SAbstractEvaluatorWithPathMap subclass: #SStateNavigationEvaluator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Dev-Evaluation'!

!SStateNavigationEvaluator class methodsFor: 'constants' stamp: 'mp 11/28/2012 15:53:53.424'!
fileName
	
	^ 'stateNavigation'! !

!SStateNavigationEvaluator class methodsFor: 'constants' stamp: 'mp 11/29/2012 16:34:53.313'!
measurementHeaders

	^ {'Mutation number'. 'Mutated method'. 'Mutation type'. 'Failing test'. 'Method calls'. 'Defect (first)'. 'Defect (last)'. 'Violated contract number'. 'Violated method call'. 'Violated Call Id'. 'Type of violation'. 'Type of contract'}! !

!SStateNavigationEvaluator class methodsFor: 'constants' stamp: 'mp 11/29/2012 14:34:31.546'!
repetition

	^ 5! !

!SStateNavigationEvaluator methodsFor: 'infections' stamp: 'mp 11/29/2012 16:43:09.17'!
analyzeViolations: aCollection with: measurementData
	| defectData violationsData violation |
	defectData := measurementData.
	defectData
		add: aCollection first id;
		add: aCollection last id.	
	aCollection withIndexDo: [:node :index | 
		violation := node violations atRandom.
		violationsData := OrderedCollection new.
		violationsData 
			add: index;
			add: node methodReference asString;
			add: node id;
			add: violation messageText;
			add: violation kindOf asString.		
		self measurements add: defectData, violationsData.	
		].
			
! !

!SStateNavigationEvaluator methodsFor: 'infections' stamp: 'mp 11/29/2012 15:41:16.391'!
computeInfectionChainForMutation: anIndex
	| mutation mutationData |
	mutation := (MEMutationFactory onSourcecode
		scope: (MEMutationScope new
					addClasses: SProject current allClassesWithoutTests; 
					yourself))
		randomMutation.
	mutationData := OrderedCollection new 
		add: anIndex;
		add: (mutation parameters at: #method) asString;
		add: mutation class asString;
		yourself.
	mutation doMutated: [
		self doWithContracts: [
			self findInfectionChainsFor: mutationData]].		! !

!SStateNavigationEvaluator methodsFor: 'helper' stamp: 'mp 11/28/2012 17:15:36.624'!
createDynamicContracts
	self inductiveOptions isAddingContractsPossible
		ifFalse: [self inductiveOptions removeContracts].
	self inductiveOptions addContracts.! !

!SStateNavigationEvaluator methodsFor: 'helper' stamp: 'mp 11/29/2012 14:59:52.663'!
doWithContracts: aBlock

	[self createDynamicContracts.
	aBlock value]
		ensure: [self removeDynamicContracts]! !

!SStateNavigationEvaluator methodsFor: 'infections' stamp: 'mp 11/29/2012 16:28:50.004'!
findInfectionChainsFor: aMutationData
	| failingTests testData result tracer violatedNodes |
	self pathMap runTests: #suiteAll.
	failingTests := self pathMap tracer testResults keys 
		reject: [:each | each lastResult hasPassed].
	failingTests do: [:each |
		testData := OrderedCollection new.
		testData add: each asString.
		tracer := self createDynamicTracerModel.
		tracer withContracts: true.
		result := tracer 
						traceTest: each testClass 
						method: each selector.
		testData add: tracer currentId.
		violatedNodes := (tracer callgraphModel getAllNodes 
			select: [:node | node violations notEmpty]) 
			sortBy: [:a :b | a id < b id].
		violatedNodes
			ifEmpty: [self measurements add: aMutationData, testData]
			ifNotEmpty: [self analyzeViolations: violatedNodes 
								with: aMutationData, testData].			
		tracer := nil].! !

!SStateNavigationEvaluator methodsFor: 'harvesting' stamp: 'mp 11/28/2012 17:14:06.86'!
harvestInvariants
	SHarvester subclasses do: [:each | 
		self inductiveOptions setKindOfAnalysis: each.	
		self pathMap runTests: #suiteAll with: #inductive].! !

!SStateNavigationEvaluator methodsFor: 'helper' stamp: 'mp 11/28/2012 17:14:18.698'!
inductiveOptions

	^ self pathMap options at: #inductive! !

!SStateNavigationEvaluator methodsFor: 'infections' stamp: 'mp 11/29/2012 15:35:32.43'!
measureInfectionChains

	1 to: self class repetition do: [:index |
		self computeInfectionChainForMutation: index.
		index \\ 10 = 0
			ifTrue: [self saveIntoFile]].! !

!SStateNavigationEvaluator methodsFor: 'helper' stamp: 'mp 11/29/2012 15:00:00.149'!
removeDynamicContracts
	self inductiveOptions isRemovingContractsPossible 
		ifTrue: [self inductiveOptions removeContracts]! !

!SStateNavigationEvaluator methodsFor: 'hooks' stamp: 'mp 11/29/2012 14:33:01.962'!
runMeasurements
	
	self 
		initializePathMap;
		harvestInvariants;
		measureInfectionChains.! !

SAbstractEvaluatorWithPathMap subclass: #SStructureNavigationEvaluator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Dev-Evaluation'!

!SStructureNavigationEvaluator class methodsFor: 'constants' stamp: 'mp 11/28/2012 16:38:29.408'!
fileName
	
	^ 'structureNavigation'! !

!SStructureNavigationEvaluator class methodsFor: 'constants' stamp: 'mp 11/28/2012 16:39:27.448'!
measurementHeaders

	^ {'Method'. 'Complexity'. '#Tests'. 'run-time in ms'.}! !

!SStructureNavigationEvaluator methodsFor: 'hooks' stamp: 'mp 11/28/2012 16:40:31.517'!
runMeasurements
	| coveredMethods browser row begin |
	self initializePathMap.
	coveredMethods := ((self methodsCoveredByTestsOn: #faultLocalization) 
							select: [:each | each compiledMethod complexity > 1]) 
								asSortedCollection.
	coveredMethods do: [:each | 
		[Transcript show: DateAndTime now; space; show: each asString; cr.
		row := OrderedCollection new.
		browser := SystemBrowser default 
					fullOnClass: each actualClass selector: each methodSymbol.
		row 
			add: each asString;
			add: each compiledMethod complexity;
			add: each compiledMethod coveringTests size.
		begin := DateAndTime now.
		browser faultLocalizationAtStatements: self pathMap tracer.
		row add: DateAndTime now - begin.
		browser dependents first abandon.]
			on: Error do: [:e | row add: 'Error thrown!!'].
		self measurements add: row]
		displayingProgress: 'Run fault localization refinement for ', 
							coveredMethods size asString, 
							' methods.'.	! !

SAbstractEvaluatorWithPathMap subclass: #STeamNavigationEvaluator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Dev-Evaluation'!

!STeamNavigationEvaluator class methodsFor: 'as yet unclassified' stamp: 'mp 11/28/2012 15:53:47.983'!
fileName
	
	^ 'teamNavigation'! !

!STeamNavigationEvaluator class methodsFor: 'as yet unclassified' stamp: 'mp 11/28/2012 15:55:28.608'!
measurementHeaders

	^ {'Method'. 'Author'. 'Passed'. 'Failed'. 'Suspiciousness'. 'Method rank'. 'Methods with same suspiciousness'. 'Number of suspicious methods'. 'FL Developer rating'. 'FL Author rank'. 'FL Number of authors'. 'Coverage rating'. 'Coverage rank'. 'Coverage number of authors'.}! !

!STeamNavigationEvaluator methodsFor: 'measurements' stamp: 'mp 11/28/2012 16:05:06.074'!
addAuthor: aMethodReference to: aCollection
	| author |
	author := aMethodReference compiledMethod authorLastChange.
	aCollection add: author.
	^ author! !

!STeamNavigationEvaluator methodsFor: 'measurements' stamp: 'mp 11/28/2012 16:07:03.666'!
addCoverageRanking: aMethodReference to: aCollection		
	| coveredMethods coveredAuthors author ranking methodsPerAuthor rankedAuthor |
	coveredMethods := self pathMap tracer 						
								getAllCoveredMethodsFromFailedTests keys.
	coveredAuthors := coveredMethods 
							inject: Set new 
							into: [:set :meth | 
								author := meth compiledMethod authorLastChange.
								set 
									add: author; 
									yourself].
		
	ranking := (coveredAuthors collect: [:each | 
			methodsPerAuthor := coveredMethods 
				select: [:meth | meth compiledMethod lastChange first = each].
			each -> (methodsPerAuthor size / coveredMethods size)]) 
				asSortedCollection: [:a :b | a value > b value].
	rankedAuthor := ranking detect: [:assoc | assoc key = author] ifNone: [nil].
	rankedAuthor
		ifNil: [2 timesRepeat: [aCollection add: 'N/A']]
		ifNotNil: [aCollection 
					add: rankedAuthor value asFloat;
					add: (ranking indexOf: rankedAuthor)].
	aCollection add: ranking size.! !

!STeamNavigationEvaluator methodsFor: 'measurements' stamp: 'mp 11/28/2012 16:06:46.737'!
addDeveloperRanking: aMethodReference to: aCollection	
	| author ranking opportuneAuthor overallRanking |
	author := aMethodReference compiledMethod authorLastChange.
	ranking := self pathMap tracer mostOpportuneAuthorsWith: #authorLastChange.
	opportuneAuthor := ranking detect: [:assoc | assoc key = author] ifNone: [nil].
	overallRanking := ranking inject: 0 into: [:sum :ea | sum + ea value].
	opportuneAuthor 
		ifNil: [2 timesRepeat: [aCollection add: 'N/A']]
		ifNotNil: [aCollection
					add: opportuneAuthor value / overallRanking;
					add: (ranking indexOf: opportuneAuthor)].
	aCollection add: ranking size.! !

!STeamNavigationEvaluator methodsFor: 'measurements' stamp: 'mp 11/28/2012 16:04:52.62'!
addMethod: aMethodReference to: aCollection
	aCollection add: aMethodReference asString.! !

!STeamNavigationEvaluator methodsFor: 'measurements' stamp: 'mp 11/28/2012 16:06:23.851'!
addSuspiciousMethods: aMethodReference to: aCollection
	| suspiciousMethods method rank nextElement sameScore |
	suspiciousMethods := self pathMap tracer mostSuspiciousMethods.
	method := suspiciousMethods 
				detect: [:assoc | assoc key = aMethodReference] ifNone: [nil].
	method
		ifNil: [4 timesRepeat: [aCollection add: 'N/A']]
		ifNotNil: [
			rank := (suspiciousMethods indexOf: method).
			aCollection 
					add: method value first;
					add: rank.
				nextElement := suspiciousMethods at: rank + 1.
				sameScore := 0.
				[nextElement value first = method value first] 
					whileTrue: [	sameScore := sameScore + 1.
								nextElement := suspiciousMethods 
													at: rank + 1 + sameScore].
				aCollection add: sameScore.
				aCollection add: suspiciousMethods size.].! !

!STeamNavigationEvaluator methodsFor: 'measurements' stamp: 'mp 11/28/2012 16:05:22.969'!
addTestResultsTo: aCollection
	aCollection
		add: self pathMap tracer allPassed;
		add: self pathMap tracer allFailures.! !

!STeamNavigationEvaluator methodsFor: 'hooks' stamp: 'mp 11/28/2012 16:04:19.118'!
runMeasurements
	| coveredMethods row wrapper |
	self initializePathMap.
	coveredMethods := self methodsCoveredByTests asSortedCollection.
	((1 to: (coveredMethods size // 50) + 1) collect: [:each | each - 1 * 50 + 1])
		do: [:start | | stop |
	stop := start + 49.
	stop := stop min: coveredMethods size.
	(coveredMethods copyFrom: start to: stop) do: [:each | 
		Transcript show: DateAndTime now; space; show: each asString; cr.
		row := OrderedCollection new.
		[wrapper := SBlockMethodWrapper 
						on: each methodSymbol inClass: each actualClass.
		wrapper install.
		[self pathMap runTests: #suiteAll with: #faultLocalization.
		self 
			addMethod: each to: row;
			addAuthor: each to: row;
			addTestResultsTo: row;
			addSuspiciousMethods: each to: row;
			addDeveloperRanking: each to: row;
			addCoverageRanking: each to: row]
		on: Error do: [:e | row add: 'Error thrown!!']
		] ensure: [
			wrapper uninstall.
			self pathMap tracer: nil.
			Smalltalk garbageCollect].
		self measurements add: row]
		displayingProgress: 'Run developer ranking for ', 
							coveredMethods size asString, 
							' methods.'.
		self saveIntoFile].! !

SAbstractEvaluator subclass: #SBehaviorNavigationEvaluator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Dev-Evaluation'!

!SBehaviorNavigationEvaluator class methodsFor: 'constants' stamp: 'mp 11/28/2012 16:19:08.679'!
fileName
	
	^ 'behaviorNavigation'! !

!SBehaviorNavigationEvaluator class methodsFor: 'constants' stamp: 'mp 11/28/2012 16:20:13.672'!
measurementHeaders

	^ {'test name'. 'test passed'. ('test run-time x, ', self repetition). 'SA test passed'. 'SA run-time'. 'SA call nodes'. 'SA memory'. 'RA run-time'.}! !

!SBehaviorNavigationEvaluator class methodsFor: 'constants' stamp: 'mp 11/28/2012 16:20:21.093'!
repetition

	^ 10! !

!SBehaviorNavigationEvaluator methodsFor: 'measurements' stamp: 'mp 11/28/2012 16:24:58.298'!
measureCommonTestBehavior: aTestReference on: aCollection
	aCollection 
		add: aTestReference asStringOrText;
		add: (self runTest: aTestReference) hasPassed asString;
		add: [self class repetition 
				timesRepeat: [self runTest: aTestReference]] timeToRun.! !

!SBehaviorNavigationEvaluator methodsFor: 'measurements' stamp: 'mp 11/28/2012 16:27:57.015'!
measureRefinementAnalysis: aTestReference on: aCollection
	| tracer callNode id |
	tracer := self createDynamicTracerModel.
	tracer 	traceTest: aTestReference actualClass 
			method: aTestReference methodSymbol.
	id :=  ((tracer currentId - 1) / 2) asInteger.
	id <= 0 "e.g. ClassTestCase triggers no behavior in partial traces"
		ifTrue: [aCollection add: 'N/A']
		ifFalse: [	
			callNode := tracer getNode: id.
			aCollection add: [tracer explore: #return on: callNode] timeToRun.].
	Smalltalk garbageCollect.		! !

!SBehaviorNavigationEvaluator methodsFor: 'measurements' stamp: 'mp 11/28/2012 16:26:17.818'!
measureShallowAnalysis: aTestReference on: aCollection
	| tracer result runtime bytesBefore |
	bytesBefore := self getCurrentMemoryConsumption.
	tracer := self createDynamicTracerModel.
	runtime := [result := tracer 
						traceTest: aTestReference actualClass 
						method: aTestReference methodSymbol] timeToRun.
	aCollection
		add: result hasPassed;
		add: runtime;
		add: tracer currentId;
		add: self getCurrentMemoryConsumption - bytesBefore.
	tracer := nil.
	Smalltalk garbageCollect.! !

!SBehaviorNavigationEvaluator methodsFor: 'hooks' stamp: 'mp 11/28/2012 16:23:54.743'!
runMeasurements
	| tests stats | 
	tests := SProject current allTestsWithoutLongRunning.
	tests do: [:each | 
			stats := OrderedCollection new.
			self 
				measureCommonTestBehavior: each on: stats;
				measureShallowAnalysis: each on: stats;
				measureRefinementAnalysis: each on: stats.
			self measurements add: stats] 
		displayingProgress: 'Run Test Measurements of ', 
			SProject current projectName asString.! !

SAbstractEvaluator subclass: #SProjectStatisticsEvaluator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Dev-Evaluation'!

!SProjectStatisticsEvaluator class methodsFor: 'constants' stamp: 'mp 11/28/2012 15:39:46.785'!
fileName
	
	^ 'projectStatistics'! !

!SProjectStatisticsEvaluator class methodsFor: 'constants' stamp: 'mp 11/28/2012 15:41:46.891'!
measurementHeaders
	
	^ {'Project Name'. '#Categories'. '#Classes'. '#Methods'. '#Methods Complexity > 1'. 
	'LoC'. '#Tests'. 'Test Coverage'.}! !

!SProjectStatisticsEvaluator methodsFor: 'coverage' stamp: 'mp 11/28/2012 15:47:14.983'!
getTestCoverage
	| tests wrappers coverage |
	tests := SProject current allTestsWithoutLongRunning 
				collect: [:each | STestCaseEntryPoint onTestMethodReference: each].
	wrappers := self installWrappersOfType: STestCoverageWrapper.
	[tests 
		do: [:each | 
			wrappers do: [:wrapper | wrapper currentTest: each].
			each execute] 
		displayingProgress: 'Run Tests for Coverage of ', 
							SProject current projectName asString.
	coverage := (wrappers select: [:each | each tests notEmpty]) size / 
					SProject current nom]
	ensure: [wrappers do: [:each | each uninstall].
		      STestCoverageWrapper nuke.
		      Smalltalk garbageCollect].
	^ coverage asFloat! !

!SProjectStatisticsEvaluator methodsFor: 'coverage' stamp: 'mp 11/28/2012 15:46:20.97'!
installWrappersOfType: aClass
	| wrappers wrapper |
	wrappers := OrderedCollection new.
	SProject current allMethods do: [:each | 
		wrapper := aClass on: each methodSymbol inClass: each actualClass.
		wrapper ifNotNil: [wrappers add: wrapper]].
	wrappers do: [:each | each install].
	^ wrappers! !

!SProjectStatisticsEvaluator methodsFor: 'hooks' stamp: 'mp 11/28/2012 15:43:59.723'!
runMeasurements
	| stats |
	stats := OrderedCollection new.
	stats 
		add: SProject current projectName;
		add: SProject current nop;
		add: SProject current noc;
		add: SProject current nom;
		add: SProject current nomWithoutLowComplexity;
		add: SProject current loc;
		add: SProject current allTestsWithoutLongRunning size;
		add: self getTestCoverage;
		yourself.
	self measurements add: stats.! !

Object subclass: #SScripts
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Dev-Scripts'!

!SScripts class methodsFor: 'access' stamp: 'mp 2/3/2012 14:24:56.084'!
bucketsOfCurrentProject
	"self typesOfCurrentProject"
	SProject current harvestedBuckets explore.! !

!SScripts class methodsFor: 'building' stamp: 'ag 12/20/2011 19:24:23.514'!
buildOmniBrowserSAR
	
	self
		buildSARFrom: { 'OmniBrowser'. 'OB-Morphic'. 'OB-Standard'. 'AST'. 'Refactoring'. 'OB-Refactory'. 
							'OB-Refactoring'. 'OB-Regex'. 'OB-SUnitIntegration'. 'OB-Shout' }
		to: 'OmniBrowser.sar'
		withExtensions: {}
		withClasses: {}
		additionalPreamble: ''.! !

!SScripts class methodsFor: 'building' stamp: 'ag 12/12/2011 17:15:53.33'!
buildPathViewSAR
	
	self
		buildSARFrom: { 'SwaUtil'. 'MethodWrappers'. 'Animations'. 'TypeHarvesting'. 'FSM-Base'. 
						 'FSM-Morphic'. 'FSM-Events'. 'Connectors'. 'SSpec'. 'SightL-Tracer'. 'ConnectorsShapes'.
						 'ConnectorsText'. 'SightL-Projects'. 'SightL-Morphic'.
						 'cgprereqs-structure'. 'SightL-PV' }
		to: 'PathView.sar'
		withExtensions: { 'SightL' }
		withClasses: { STool. SPathView. SPathViewDiagramSpec. SDefinitionModel.
			 SProjectChooser. SProject. SCategoryChooser. SConcernChooser. STracer. UiIcons. UiFugueIcons 
		}
		additionalPreamble: 'NCAAConnectorMorph withAllSubclassesDo: [ :cl | cl initializeArrowDictionary ]'.! !

!SScripts class methodsFor: 'building' stamp: 'mp 6/1/2011 17:44:03.125'!
buildSAR
		| packages zip mczStream workingCopy version preamble |
	packages := {'MethodWrappers'. 'Animations'. 'TypeHarvesting'. 'SightL'}.
	zip := ZipArchive new.
	packages do: [:each | 
		mczStream := RWBinaryOrTextStream on: (String new: 100000). 	
		workingCopy := MCWorkingCopy forPackage: (MCPackage new name: each). 
		version := workingCopy newVersion. 
		version fileOutOn: mczStream.
		(zip addString: mczStream contents as: each, '.mcz') desiredCompressionLevel: 0].
	zip 
		addFile: 'ClosureExtractor.st';
		addFile: 'CompiledMethod-embeddedBlockMethods.st'.	
	preamble :=  'self fileInPackageNamed: ''ClosureExtractor.st''.'.
	preamble := preamble, 'self fileInPackageNamed: ''CompiledMethod-embeddedBlockMethods.st''.'.
	preamble := preamble, (packages 
					inject: String new 
					into: [:str :each | str := str, 'self fileInMonticelloZipVersionNamed: ''', each, '.mcz''.']).
	preamble := preamble, 'SProject setCurrent: #observerExample.'.
	zip addString: preamble as: 'install/preamble'. 
	zip writeToFileNamed: 'PathTools.sar'.! !

!SScripts class methodsFor: 'building' stamp: 'ag 12/3/2011 17:00:10.934'!
buildSARFrom: packages to: filename additionalPreamble: aString
	
	self buildSARFrom: packages to: filename withExtensions: {} withClasses: {} additionalPreamble: aString.! !

!SScripts class methodsFor: 'building' stamp: 'ag 12/20/2011 17:38:58.011'!
buildSARFrom: packages to: filename withExtensions: additionalExtensions withClasses: additionalClasses additionalPreamble: aString
	
	| zip preamble additionalSource |
	zip := ZipArchive new.
	additionalSource := WriteStream on: ''.
	preamble := WriteStream on: ''.
	packages do: [:each | | stream |
		stream := RWBinaryOrTextStream on: ''..
		self writeMcz: each on: stream.
		(zip addString: stream contents as: each, '.mcz') desiredCompressionLevel: 0. "Default is 6..."
		self fileOutExtensionsOf: each on: additionalSource skipping: additionalClasses.
		preamble nextPutAll: 'self fileInMonticelloZipVersionNamed: '''; nextPutAll: each; nextPutAll: '.mcz''.' ].
	additionalClasses do: [ :cl | cl fileOutOn: additionalSource moveSource: false toFile: 0 ].
	additionalExtensions do: [ :each | self fileOutExtensionsOf: each on: additionalSource skipping: additionalClasses ].
	preamble
		nextPutAll: 'self fileInPackageNamed: ''additionalSource.st''.';
		nextPutAll: aString.
	zip
		addString: additionalSource contents as: 'additionalSource.st';
		addString: preamble contents as: 'install/preamble';
		writeToFileNamed: filename.! !

!SScripts class methodsFor: 'menu' stamp: 'mp 3/8/2012 10:54:29.904'!
chooseScript
	"self chooseScript"
	| allScripts notListedSelectors |
	notListedSelectors := {#chooseScript. #label. #createButton. #isOn}.
	allScripts := (self class methodDict keys 
					reject: [:each | (notListedSelectors includes: each)
									or: [each includes: $:]]) sort.
	(UIManager default chooseFrom: allScripts title: 'Choose script to do it')
		ifNotNilDo: [:choice | 
			choice > 0
				ifTrue: [self perform: (allScripts at: choice)]]
	! !

!SScripts class methodsFor: 'clean up' stamp: 'mp 3/8/2012 15:29:09.921'!
countInstances
	"self countInstances"
	Smalltalk garbageCollect.
	Smalltalk garbageCollect.
	({MwMethodWrapper. SCallNode. SPMPathMapMorph. SClassMorph. SClassDiagramMorph. SMiniMap. SStateViewTracer}
		inject: Dictionary new into: [:dict :each | 
			dict 
				at: each put: each allSubInstances size;
				yourself]) explore.! !

!SScripts class methodsFor: 'button' stamp: 'mp 2/24/2011 17:59:11.852'!
createButton
	"self createButton"
	(PluggableButtonMorphPlus 
		on: SScripts 
		getState: #isOn 
		action: #chooseScript 
		label: #label) openInHand! !

!SScripts class methodsFor: 'examples' stamp: 'mp 2/24/2011 17:40:13.732'!
examplePathState
	"self examplePathState"
	(SStateViewTracer 
	onClass: SOMInterpreter 
	instVarName: #frame) run valuesAsSet explore.! !

!SScripts class methodsFor: 'examples' stamp: 'mp 2/24/2011 17:38:39.685'!
examplePathView
	"self examplePathView"
	SPathView openOn: SOMInterpreter.! !

!SScripts class methodsFor: 'building' stamp: 'ag 12/3/2011 17:02:44.386'!
fileOutExtensionsOf: packageName on: stream skipping: skippedClasses
	
	| categoryName |
	categoryName := ('*', packageName) asSymbol.
	Smalltalk allClasses
		select: [ :cl | 
			(skippedClasses includes: cl) not and: [ cl organization categories includes: categoryName ] ]
		thenDo: [ :cl |
			cl fileOutCategory: categoryName on: stream moveSource: false toFile: 0 ].! !

!SScripts class methodsFor: 'button' stamp: 'mp 2/24/2011 17:57:25.573'!
isOn
	^ true! !

!SScripts class methodsFor: 'button' stamp: 'mp 2/24/2011 17:57:13.313'!
label
	^ 'PathScripts'! !

!SScripts class methodsFor: 'clean up' stamp: 'ag 5/14/2012 12:54:07.646'!
nuke
	"self nuke"
	MwMethodWrapper nuke.
	SValueRangeBucket allInstances, THTypeBucket allSubInstances 
		do: [:each | each reset].
	SGraph deleteCurrentGraph.
	Smalltalk garbageCollect.
	Smalltalk garbageCollect.
	SClassDiagramMorph allSubInstances do: [:each | each abandon].
	SMiniMap allInstances do: [:each | each abandon].
	self assert: [MwMethodWrapper allSubInstances size = 0].
	self assert: [SMiniMap allInstances size = 0]. 
	self inform: 'Clean up done'! !

!SScripts class methodsFor: 'access' stamp: 'mp 2/24/2011 17:44:18.439'!
typesOfCurrentProject
	"self typesOfCurrentProject"
	SProject current typesBucket explore.! !

!SScripts class methodsFor: 'building' stamp: 'ag 12/20/2011 17:43:12.743'!
writeMcz: aPackageName
	
	^ self writeMcz: aPackageName on: (FileStream forceNewFileNamed: aPackageName, '.mcz')! !

!SScripts class methodsFor: 'building' stamp: 'ag 12/20/2011 17:39:24.748'!
writeMcz: aPackageName on: aStream
	
	^ (MCPackage named: aPackageName) workingCopy newVersion fileOutOn: aStream! !

Object subclass: #Subject
	instanceVariableNames: 'observers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Dev-Example-Observer'!

Subject subclass: #ClockTimer
	instanceVariableNames: 'hour minute second'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Dev-Example-Observer'!

!ClockTimer methodsFor: 'accessing' stamp: 'fg 4/12/2010 15:22'!
hour
	"Answer the value of hour"

	^ hour! !

!ClockTimer methodsFor: 'accessing' stamp: 'fg 4/12/2010 15:22'!
hour: anObject
	"Set the value of hour"

	hour := anObject! !

!ClockTimer methodsFor: 'initialize-release' stamp: 'mp 9/29/2010 15:06:34.806'!
initialize
	| time |
	super initialize.
	time := Time midnight.
	hour := time hour.
	minute := time minute.
	second := time second.! !

!ClockTimer methodsFor: 'accessing' stamp: 'fg 4/12/2010 15:22'!
minute
	"Answer the value of minute"

	^ minute! !

!ClockTimer methodsFor: 'accessing' stamp: 'fg 4/12/2010 15:22'!
minute: anObject
	"Set the value of minute"

	minute := anObject! !

!ClockTimer methodsFor: 'accessing' stamp: 'fg 4/12/2010 15:22'!
second
	"Answer the value of second"

	^ second! !

!ClockTimer methodsFor: 'accessing' stamp: 'fg 4/12/2010 15:22'!
second: anObject
	"Set the value of second"

	second := anObject! !

!ClockTimer methodsFor: '-- all --' stamp: 'mp 4/28/2010 13:55'!
tick
	"update internal time-keeping state"
	| time |
	time := (Time hour: hour minute: minute second: second) addSeconds: 1.
	hour := time hour.
	minute := time minute.
	second := time second.
	self notify.! !

!Subject methodsFor: 'observation' stamp: 'fg 4/12/2010 15:14'!
attach: anObserver
	observers add: anObserver! !

!Subject methodsFor: 'observation' stamp: 'fg 4/12/2010 15:15'!
detach: anObserver
	observers remove: anObserver! !

!Subject methodsFor: 'initialize-release' stamp: 'fg 4/12/2010 15:14'!
initialize
	observers := OrderedCollection new! !

!Subject methodsFor: 'observation' stamp: 'mp 4/28/2010 13:32'!
notify
	observers do: [ :obs | obs update: self ].! !

TestCase subclass: #TestDriver
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Dev-Example-Observer'!

!TestDriver methodsFor: 'running' stamp: 'tfel 2/14/2012 10:18:16.75'!
tearDown

	super tearDown.
	World changed.! !

!TestDriver methodsFor: 'testing' stamp: 'mp 9/29/2010 14:02:17.276'!
testNoop

	self assert: self class == TestDriver! !

!TestDriver methodsFor: 'testing' stamp: 'tfel 2/14/2012 10:13:19.64'!
testRun
	| timer analogClock digitalClock |

	timer := ClockTimer new.
	analogClock := SAnalogClock on: timer.
	digitalClock := SDigitalClock on: timer.
	
	timer tick.! !

SWrapper subclass: #SBlockMethodWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Dev-Evaluation-Wrapper'!

!SBlockMethodWrapper methodsFor: 'evaluating' stamp: 'mp 9/29/2011 15:52:05.335'!
valueWithReceiver: anObject arguments: anArrayOfObjects

	^ anObject! !

SCallWrapper subclass: #SExploreEvaluationWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Dev-Evaluation-Wrapper'!

!SExploreEvaluationWrapper methodsFor: '-- all --' stamp: 'mp 2/6/2010 18:23'!
afterMethod! !

!SExploreEvaluationWrapper methodsFor: '-- all --' stamp: 'mp 2/16/2010 20:15'!
aroundWithReceiver: aReceiver arguments: anArrayOfObjects
	
	| result types |
	"#arguments #selfBefore #selfAfter #return #types"
	self tracer isActive ifTrue: [
		self tracer stopTracing.
		anArrayOfObjects isEmpty not
			ifTrue: [	types := OrderedCollection new.
					anArrayOfObjects do: [:each | types add: each class].
					types add: aReceiver class.
					self tracer addView: types to: #types.
					"self tracer addView: anArrayOfObjects veryDeepCopy to: #arguments.
					self tracer addView: aReceiver veryDeepCopy to: #selfBefore."
					].
		self tracer startTracing].
	^ [result := self proceed: aReceiver arguments: anArrayOfObjects.
	     result]
		ensure: [ 	
			self tracer isActive ifTrue: [
				self tracer stopTracing.
				"self tracer addView: aReceiver veryDeepCopy to: #selfAfter.
				self tracer addView: result veryDeepCopy to: #result."
				self tracer addView: result class to: #resultType.
				self tracer startTracing]]! !

!SExploreEvaluationWrapper methodsFor: '-- all --' stamp: 'mp 2/6/2010 18:23'!
beforeMethod! !
